spring.profiles.active=${SPRING_PROFILES_ACTIVE:default}
spring.jackson.date-format=yyyy-MM-dd HH:mm:ss
spring.jackson.time-zone=Asia/Jakarta
spring.mustache.check-template-location=false

# Tomcat
server.port=${PORT:8080}
## connection
server.tomcat.threads.max=${SERVER_TOMCAT_THREAD_MAX:210}
server.tomcat.threads.min-spare=${SERVER_TOMCAT_MIN_SPARE:30}
server.tomcat.max-connections=${SERVER_TOMCAT_MAX_CONNECTION:15000}
#server.tomcat.processor-cache=20
#server.connection-timeout=30s
#server.max-http-header-size=50KB
#server.tomcat.max-swallow-size=2MB
#server.tomcat.max-http-post-size=2MB
## ssl
#server.ssl.enabled=true
#server.ssl.protocol=TLS
#server.ssl.key-store-password=my_password
#server.ssl.key-store-type=keystore_type
#server.ssl.key-store=keystore-path
#server.ssl.key-alias=tomcat
## default error page
#server.error.whitelabel.enabled=true
#server.error.path=/user-error
#server.error.include-exception=true
#server.error.include-stacktrace=always

spring.jpa.open-in-view=true
spring.jpa.properties.hibernate.types.print.banner=false

# Disable devtools - default true
spring.devtools.add-properties=true

## to Json Pretty print in browser
spring.jackson.serialization.indent-output=true

# security
#spring.security.strategy: MODE_INHERITABLETHREADLOCAL ## deactivate when using DelegatingSecurityContextAsyncTaskExecutor see: AsyncConfig class
spring.security.user.name=${SPRING_SEC_USER:rey}
spring.security.user.password=${SPRING_SEC_PASS:rey}
spring.cors.allowed.origin=${ALLOWED_ORIGIN:*}

spring.datasource.url=jdbc:h2:mem:testdb
spring.datasource.driverClassName=org.h2.Driver
spring.datasource.username=dbuser
spring.datasource.password=dbpass
spring.jpa.database-platform=org.hibernate.dialect.H2Dialect

# H2
spring.h2.console.enabled=true
spring.h2.console.path=/h2-console

#Postgres DB
#spring.jpa.database=POSTGRESQL
#spring.jpa.database-platform=org.hibernate.dialect.PostgreSQLDialect
spring.jpa.properties.hibernate.show_sql=false
spring.jpa.show-sql=false
spring.jpa.generate-ddl=false
spring.jpa.hibernate.ddl-auto=create-drop
spring.jpa.properties.hibernate.jdbc.lob.non_contextual_creation=true
spring.jpa.properties.hibernate.enable_lazy_load_no_trans=true

#spring.datasource.platform=postgres
#spring.datasource.driverClassName=org.postgresql.Driver
#spring.datasource.url=jdbc:postgresql://${DB_HOST:localhost}:${DB_PORT:5432}/${DB_NAME:reydb}
#spring.datasource.username=${DB_USER:userrey}
#spring.datasource.password=${DB_PASS:passrey}

# REDIS CONFIG
spring.data.redis.database=${REDIS_DB_INDEX:0}
spring.data.redis.host=${REDIS_HOST:localhost}
spring.data.redis.password=${REDIS_PASS:password123}
spring.data.redis.port=${REDIS_PORT:6379}
spring.data.redis.timeout=${REDIS_TIMEOUT_MS:2000}
spring.data.redis.connect-timeout=${REDIS_CONNECT-TIMEOUT-SEC:10}
#spring.data.redis.ssl=${REDIS_SSL:false}
#spring.data.redis.host=${REDIS_HOST:caching-dev.pegadaian.co.id}
#spring.data.redis.user=${REDIS_USER:dev_caching_user}
#spring.data.redis.password=${REDIS_PASS:5638c32be721c6e73c2c185c01a19dc17c41aa17}
#spring.data.redis.port=${REDIS_PORT:6379}
spring.redis.connection.lazy-initialization=true

# REDIS POOL CONFIG
spring.data.redis.jedis.pool.enabled=${REDIS_POOL_ENABLE:true}
spring.data.redis.jedis.pool.max-active=${REDIS_POOL_MAX-ACTIVE:8}
spring.data.redis.jedis.pool.max-idle=${REDIS_POOL_MAX-IDLE:8}
spring.data.redis.jedis.pool.max-wait=${REDIS_POOL_MAX-WAIT:-1}
spring.data.redis.jedis.pool.min-idle=${REDIS_POOL_MIN-IDLE:0}
spring.data.redis.jedis.pool.time-between-eviction-runs=${REDIS_POOL_EVICTION-RUN-TIME-SEC:60}

# Logging config
logging.pattern.level=X-Request-ID=%X{X-Request-ID} %5p
#logging.level.org.atmosphere=DEBUG
#logging.level.org.springframework=DEBUG
#logging.level.org.springframework.web=DEBUG
logging.level.org.springframework.web.filter.CommonsRequestLoggingFilter=DEBUG
logging.level.org.apache.http.wire=DEBUG
logging.level.org.hibernate.SQL=WARN
log4j.logger.httpclient.wire=DEBUG
#logging.level.org.hibernate.type.descriptor.sql=TRACE
logging.level.com.zaxxer.hikari=ERROR
logging.level.com.zaxxer.hikari.HikariConfig=ERROR

# Hikari will use the above plus the following to setup connection pooling
## minimum number of idle connections maintained by HikariCP in a connection pool
spring.datasource.hikari.minimumIdle=${HIKARI_OPT_MINIMUM_IDLE:30}
## maximum pool size
spring.datasource.hikari.maximumPoolSize=${HIKARI_OPT_MAX_POOL_SIZE:60}
## maximum idle time for connection
spring.datasource.hikari.idleTimeout=${HIKARI_OPT_IDE_TIME_OUT:60000}
## name
spring.datasource.hikari.poolName=SpringBootJPAHikariCP
## maximum lifetime in milliseconds of a connection in the pool after it is closed.
spring.datasource.hikari.maxLifetime=${HIKARI_OPT_MAX_LIFE_TIME:1800000}
## maximum number of milliseconds that a client will wait for a connection
spring.datasource.hikari.connectionTimeout=${HIKARI_OPT_CON_TIME_OUT:30000}
## hikari leak detection
spring.datasource.hikari.leakDetectionThreshold=${HIKARI_LD_THRESHOLD:0}